#include "omp.h"

#include "emmintrin.h"
#include "nmmintrin.h"

#include "defs.h"

void conv_filter(int imgHeight, int imgWidth, int imgHeightF, int imgWidthF,
				 int imgFOfssetH, int imgFOfssetW,
				 float *filter, float *imgFloatSrc, float *imgFloatDst)
{
	// rsi bzis: 2. sor, 2. oszlop
	int wr_base = (imgFOfssetW*imgWidthF + imgFOfssetH)*4;
	// olvassi bzis: a kiterjesztett kp bal fels pixele
	int rd_base = 0;
	
	// 2 <= row < 1202
	for (int row=imgFOfssetH; row<(imgHeight+imgFOfssetH); row++)
	{
		// 2 <= col < 1982
		for (int col=imgFOfssetW; col<(imgWidth+imgFOfssetW); col++)
		{
			// a konvolci sorn mdostott olvassi offszet
			int rd_offset = 0;
			// RGBA komponensek akkumultora
			float fval[4] = {0.0f, 0.0f, 0.0f, 0.0f};
			
			// konvolci minden komponensre
			
			
			// kimenet pixel rsa

		}
	}
}


void conv_filter_sse(int imgHeight, int imgWidth, int imgHeightF, int imgWidthF,
				 int imgFOfssetH, int imgFOfssetW,
				 float *filter, float *imgFloatSrc, float *imgFloatDst)
{

	__declspec(align(16)) __m128 const_0 = _mm_set_ps(0.0, 0.0, 0.0, 0.0);
    __declspec(align(16)) __m128 const_255 = _mm_set_ps(255.0, 255.0, 255.0, 255.0);

	// szr egytthatk ngyszerezse
	float filter_ext[4*FILTER_W*FILTER_H];
	for (int i=0; i<4*FILTER_W*FILTER_H; i++)
		filter_ext[i] = filter[i/4];
	
	// float -> m128 konverzi
	__declspec(align(16)) __m128 filter_l[FILTER_W*FILTER_H];
	for (unsigned int i=0; i<4*FILTER_W*FILTER_H; i++)
		filter_l[i>>2].m128_f32[i&0x3]=*(filter_ext+i);




}